
#include <windows.h>
#include <time.h>
#include <string>
#include <sstream>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_ttf.h>
#include <string>
#include "Tools.h"
#include "SDLgraph.h"
#include "main.h"


using namespace std;

SDL_Renderer *SDLren = NULL;


string floatstr(float f)
{
	stringstream oss;
	oss << f;
	string str;
	str = oss.str();

	return str;
}

int main(int argc, char** argv)
{

	if (SDL_Init(SDL_INIT_VIDEO) == -1) error("SDL_Init");

	SDL_Window *SDLwin = NULL;
	SDLwin = SDL_CreateWindow("FPS Test", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, screenwidth, screenheight, NULL);
	if (!SDLwin) error("SDL_CreateWindow");
	
	SDLren = SDL_CreateRenderer(SDLwin, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC); 
	if (!SDLren) error("SDL_CreateRenderer");


	srand((unsigned int) time(NULL));

		
	int flags=IMG_INIT_JPG | IMG_INIT_PNG | IMG_INIT_TIF;
	int initted=IMG_Init(flags);
	if((initted & flags) != flags) error("Unable to initialize SDL2_Image: "+ (string) SDL_GetError());


	if (TTF_Init() < 0) error("TTF_Init fails: " + (string) SDL_GetError());  


	TTF_Font *myFont;
	if (!(myFont = TTF_OpenFont("arial.ttf", 36))) error("TTF_OpenFont 'arial.ttf' fails: " + (string) SDL_GetError());




	SDL_Texture *sdlTexture = SDL_CreateTexture(SDLren,
                                            SDL_PIXELFORMAT_ARGB8888,
                                            SDL_TEXTUREACCESS_STREAMING,
                                            screenwidth, screenheight);
	if (!sdlTexture) error("failed to create a texture");



	SDL_Surface *screen = SDL_CreateRGBSurface(0, screenwidth, screenheight, 32,0,0,0,0);
	if (!screen) error("screen alloc fail: "+(string) SDL_GetError());


	SDL_Surface *img = LoadIMG("test.jpg");


	SDL_Texture* colorsTexture = LoadTexture("alphaball.png");
	//SDL_SetTextureAlphaMod( colorsTexture, 128 );
	
	

	unsigned int dwFrames = 0;
	unsigned int dwCurrentTime = 0;
	unsigned int dwLastUpdateTime = 0;
	unsigned int dwElapsedTime = 0;
	string theFPS="";

	bool quit=false;
	while (!quit)
	{

		SDL_Event e;
		while (SDL_PollEvent(&e))
		{
			switch(e.type) 
			{
				case SDL_QUIT: { quit = true; } break;
				case SDL_KEYDOWN: 
				{
					switch (e.key.keysym.sym)
					{
						case SDLK_ESCAPE: {quit = true;} break;
						default: break;
					}
				} break;
				default: break;
			}
		}


        SDL_SetRenderDrawColor(SDLren, 0, 0, 0, 255);
		SDL_RenderClear(SDLren);


		
			SDL_BlitSurface(img, NULL, screen, NULL);	









		dwFrames++;
		dwCurrentTime = SDL_GetTicks();
		dwElapsedTime = dwCurrentTime - dwLastUpdateTime;
		
		if(dwElapsedTime >= 1000)
		{
			 theFPS = floatstr((float) dwFrames * 1000.0f / dwElapsedTime)+"fps";
			dwFrames = 0;
			dwLastUpdateTime = dwCurrentTime;
		}
		

		TextOutSurface(10, 10, theFPS , RGBA32(255,255,255,255), screen, myFont);





		SDL_UpdateTexture(sdlTexture, NULL, screen->pixels, screen->pitch);

		SDL_RenderCopy(SDLren, sdlTexture, NULL, NULL);


		SDL_RenderCopy(SDLren, colorsTexture, NULL, NULL);



		SDL_RenderPresent(SDLren);


	}




	TTF_CloseFont(myFont);

	SDL_FreeSurface(screen);

    SDL_DestroyTexture(sdlTexture);

	SDL_DestroyRenderer(SDLren);
	SDL_DestroyWindow(SDLwin);
	
	
	TTF_Quit();
	SDL_Quit();



	return 0;
}