
#include <windows.h>
#include <string>
#include <SDL.h>
#include "Tools.h"
#include "SDLgraph.h"
#include "main.h"

SDL_Renderer *SDLren = NULL;

int main(int argc, char** argv)
{

	if (SDL_Init(SDL_INIT_VIDEO) == -1) error("SDL_Init");

	SDL_Window *SDLwin = NULL;
	SDLwin = SDL_CreateWindow("first Test", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, 800, 600, NULL);
	if (!SDLwin) error("SDL_CreateWindow");
	
	SDLren = SDL_CreateRenderer(SDLwin, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC); 
	if (!SDLren) error("SDL_CreateRenderer");





	SDL_Texture* image = LoadTexture("test.bmp");

	SDL_Texture* sprite = LoadTexture("pinguing.bmp");

	int X=100;
	int Y=100;

	
	bool quit=false;
	while (!quit)
	{

		SDL_Event e;
		while (SDL_PollEvent(&e))
		{
			switch(e.type) 
			{
				case SDL_MOUSEMOTION:
				{
					X=e.motion.x;
					Y=e.motion.y;
				} break;
				case SDL_QUIT: { quit = true; } break;
				case SDL_KEYDOWN: 
				{
					switch (e.key.keysym.sym)
					{
						case SDLK_ESCAPE: {quit = true;} break;
						default: break;
					}
				} break;

				default: break;
			}
		}
	
		const Uint8* currentKeyStates = SDL_GetKeyboardState( NULL );
		if( currentKeyStates[ SDL_SCANCODE_LEFT ] ) X--;
		if( currentKeyStates[ SDL_SCANCODE_RIGHT ] ) X++;



        SDL_SetRenderDrawColor(SDLren, 0, 0, 0, 255);
		SDL_RenderClear(SDLren);

        
		
		SDL_RenderCopy(SDLren, image, NULL, NULL);

        
		SDL_Rect r;
		SDL_QueryTexture(sprite, NULL, NULL, &r.w, &r.h);
		r.x=X;
		r.y=Y;
		SDL_RenderCopy(SDLren, sprite, NULL, &r);
		
		
		SDL_RenderPresent(SDLren);


	}


	
    SDL_DestroyTexture(image);


	SDL_DestroyRenderer(SDLren);
	SDL_DestroyWindow(SDLwin);
	
	SDL_Quit();



	return 0;
}