
#include <windows.h>
#include <time.h>
#include <string>
#include <SDL.h>
#include "Tools.h"
#include "SDLgraph.h"
#include "main.h"

SDL_Renderer *SDLren = NULL;

int main(int argc, char** argv)
{

	if (SDL_Init(SDL_INIT_VIDEO) == -1) error("SDL_Init");

	SDL_Window *SDLwin = NULL;
	SDLwin = SDL_CreateWindow("Pixels Test", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, screenwidth, screenheight, NULL);
	if (!SDLwin) error("SDL_CreateWindow");
	
	SDLren = SDL_CreateRenderer(SDLwin, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC); 
	if (!SDLren) error("SDL_CreateRenderer");


	srand((unsigned int) time(NULL));


	SDL_Texture *sdlTexture = SDL_CreateTexture(SDLren,
                                            SDL_PIXELFORMAT_ARGB8888,
                                            SDL_TEXTUREACCESS_STREAMING,
                                            screenwidth, screenheight);
	if (!sdlTexture) error("failed to create a texture");


	Uint32 *myPixels = (Uint32*) malloc(screenwidth*screenheight*4);




	bool quit=false;
	while (!quit)
	{

		SDL_Event e;
		while (SDL_PollEvent(&e))
		{
			switch(e.type) 
			{
				case SDL_QUIT: { quit = true; } break;
				case SDL_KEYDOWN: 
				{
					switch (e.key.keysym.sym)
					{
						case SDLK_ESCAPE: {quit = true;} break;
						default: break;
					}
				} break;
				default: break;
			}
		}


        SDL_SetRenderDrawColor(SDLren, 0, 0, 0, 255);
		SDL_RenderClear(SDLren);



		for (int y=0; y<screenheight; y++)
			for (int x=0; x<screenwidth; x++)
			{
				Uint8 col = rand() % 256;
				putpixelBuffer(myPixels,x,y,RGBA32(col,col,col,255),screenwidth);
			}




        SDL_UpdateTexture(sdlTexture, NULL, myPixels, screenwidth * sizeof (Uint32));

		SDL_RenderCopy(SDLren, sdlTexture, NULL, NULL);

		SDL_RenderPresent(SDLren);


	}


	
    SDL_DestroyTexture(sdlTexture);


	SDL_DestroyRenderer(SDLren);
	SDL_DestroyWindow(SDLwin);
	
	SDL_Quit();



	return 0;
}