
#include <string>
#include <SDL.h>
#include <SDL_image.h>
#include "Tools.h"
#include "SDLgraph.h"
#include "main.h"

SDL_Texture* LoadTexture(std::string filename)
{

	SDL_Surface *img = NULL;
	img = IMG_Load(filename.c_str());
	if (!img) error("IMG_Load "+filename+" fail");

	SDL_Texture *image = NULL;
	image = SDL_CreateTextureFromSurface(SDLren, img);
	if (!image) error("SDL_CreateTextureFromSurface");
    
	SDL_FreeSurface(img);

	return image;
}





Uint32 RGBA32(Uint8 r, Uint8 g,Uint8 b, Uint8 a)
{
	Uint32 color = ((a << 24) | ( r << 16 ) | ( g << 8 ) | b );

   if(SDL_BYTEORDER == SDL_BIG_ENDIAN) color =  SDL_Swap32(color);
   

	return color;
}

void GetRGBA32(Uint32 c, Uint8 &r, Uint8 &g, Uint8 &b, Uint8 &a)
{
	Uint32 color=c;
    
	if(SDL_BYTEORDER == SDL_BIG_ENDIAN) color =  SDL_Swap32(color);

    a = (( color >> 24 ) & 0xFF);
	r = (( color >> 16 ) & 0xFF);
	g = ( (color >> 8) & 0xFF );
	b = (color & 0xFF );
}




void putpixelSurface(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * 4;

   *(Uint32 *)p = pixel;
}




void putpixelBuffer(Uint32 *buf, int x, int y, Uint32 pixel, Uint32 width)
{
    Uint32 *p = buf + (y * width + x);
    *(Uint32 *)p = pixel;
}